*MyHeader
*     , -  General.     
*    ControlSource      
*  .       -      .
*      ,    (   ),
*   General,      ControlSource,
*    ,     .
***********************************************
*   
DEFINE CLASS MyHeader AS Header
  ToolTipText=" "
  cAscending="ASCENDING"
  ControlSource=.NULL.
  nBackColor=.NULL.
  nForeColor=.NULL.
  cNameIndex=.NULL.
*******************************
*******************************
  *       
  PROCEDURE Init
    THIS.nBackColor=THIS.BackColor
    THIS.nForeColor=THIS.ForeColor
  endPROC
*******************************
*******************************
  *         ,
  *    %)
  PROCEDURE MouseDown
    LPARAMETERS nButton, nShift, nXCoord, nYCoord
    THIS.BackColor=ROUND(THIS.BackColor/2,0)
    THIS.ForeColor=RGB(255,255,255)
    THIS.Parent.SetFocus()
  endPROC
*******************************
*******************************
  *   ,    
  PROCEDURE MouseUp
    LPARAMETERS nButton, nShift, nXCoord, nYCoord
    THIS.BackColor=THIS.nBackColor
    THIS.ForeColor=THIS.nForeColor
  endPROC
*******************************
*******************************
	*    ,   ControlSource
  * ,   .    
  * mIndex.     .  .
  PROCEDURE Click
		LOCAL lnI, lnK, llOk, lcCSParent, lcCS, lnRecNo
    IF NOT RIGHT(THIS.Caption,1)=="" OR NOT RIGHT(THIS.Caption,1)==""
      FOR lnI=1 TO THIS.Parent.Parent.ColumnCount
         FOR lnK=1 TO THIS.Parent.Parent.Columns(lnI).ControlCount
           IF THIS.Parent.Parent.Columns(lnI).Objects(lnK).BaseClass=="Header"
						 IF RIGHT(THIS.Parent.Parent.Columns(lnI).Objects(lnK).Caption,1)=="" OR ;
						 		RIGHT(THIS.Parent.Parent.Columns(lnI).Objects(lnK).Caption,1)==""
						   THIS.Parent.Parent.Columns(lnI).Objects(lnK).Caption=;
						   	 ALLTRIM(SUBSTR(THIS.Parent.Parent.Columns(lnI).Objects(lnK).Caption,1,;
						   	 LEN(THIS.Parent.Parent.Columns(lnI).Objects(lnK).Caption)-1))
						 endIF
           endIF
         endFOR
      endFOR
    endIF
    lcCSParent=THIS.Parent.ControlSource
    lcCS=THIS.ControlSource
    lnRecNo=RECNO(THIS.Parent.Parent.RecordSource)
    DO CASE
      CASE OCCURS(".",THIS.Parent.ControlSource)>=2 OR LIKE("*+*",THIS.Parent.ControlSource)
        llOk=.T.
      CASE TYPE("&lcCSParent")=="M"
        llOk=.T.
      CASE TYPE("&lcCSParent")=="G"
        llOk=.T.
    endCASE
    IF llOk
      IF ISNULL(THIS.ControlSource)
        WAIT WINDOWS " " TIMEOUT 0.75
        RETURN .F.
      ELSE
        IF NOT TYPE("&lcCS")=="M" AND NOT TYPE("&lcCS")=="G"
          THIS.mIndex(THIS.ControlSource)
        ELSE
          WAIT WINDOWS " " TIMEOUT 0.75
        endIF
      endIF
    ELSE
      IF ISNULL(THIS.ControlSource)
      	THIS.mIndex(THIS.Parent.ControlSource)
      ELSE
      	THIS.mIndex(THIS.ControlSource)
      endIF
    endIF
		THIS.Parent.Parent.Refresh()
		IF RECCOUNT(THIS.Parent.Parent.RecordSource)>=lnRecNo
      GO RECORD lnRecNo
    endIF
	endPROC
***************************
***************************
	*    /
  PROCEDURE mIndex
		LParameter lpcColumnOrder
		LOCAL lcIndex, lcIndexTmp, lcScending, lcSafety, lcTable
    lcScending=THIS.cAscending
    lcTable=THIS.Parent.Parent.RecordSource
    lcSafety=SET("SAFETY")
    SET SAFETY OFF
    lcIndexTmp=ADDBS(SYS(2023))
    IF ISNULL(THIS.cNameIndex)
      IF OCCURS(".",lpcColumnOrder)>=1
        lpcColumnOrder=SUBSTR(lpcColumnOrder,(AT(".",lpcColumnOrder)+1),;
                       LEN(lpcColumnOrder)-AT(".",lpcColumnOrder))
      endIF
		  SELECT (lcTable)
      lcIndex="i"+SUBSTR(SYS(2015),4,7)
		  lcIndexTmp=lcIndexTmp+lcIndex+".tmp"
      IF VARTYPE(&lpcColumnOrder)=="C"
        IF LEN(&lpcColumnOrder)>=100
          lpcColumnOrder="LEFT(&lpcColumnOrder,99)"
        endIF
      endIF
      WAIT WINDOW ",  " NOWAIT NOCLEAR 
      INDEX ON &lpcColumnOrder TO ALLTRIM(lcIndexTmp) ADDITIVE
		  WAIT CLEAR
		  WAIT WINDOW " " NOWAIT
		  THIS.cNameIndex=lcIndex
    ELSE
      lcIndex=THIS.cNameIndex
    endIF
    DO CASE
			CASE lcScending=="ASCENDING"
				SET ORDER TO (lcIndex) IN (lcTable) &lcScending
				THIS.cAscending="DESCENDING"
        THIS.Caption=THIS.Caption+" "
			CASE lcScending=="DESCENDING"
				SET ORDER TO (lcIndex) IN (lcTable) &lcScending
				THIS.cAscending="NOSORT"
        THIS.Caption=THIS.Caption+" "
			CASE lcScending=="NOSORT"
				SET ORDER TO
				THIS.cAscending="ASCENDING"
				THIS.Caption=THIS.Caption
			OTHERWISE
				WAIT WINDOW "  ,    , ?"
		endCASE
		SET SAFETY &lcSafety
	ENDPROC
***************************
***************************
  *   -
  PROCEDURE Destroy
    LOCAL lcSafety, lcIndexes, lcIndexTmp, llOk
    IF NOT ISNULL(THIS.cNameIndex)
      llOk=.T.
      lcSafety=SET("SAFETY")
      SET SAFETY OFF
      SELECT (THIS.Parent.Parent.RecordSource)
      SET ORDER TO
      lcIndexTmp=ADDBS(SYS(2023))
      lcIndexTmp=lcIndexTmp+THIS.cNameIndex+".tmp"
      lcIndexes=SET("INDEX")
      lcIndexes=ALLTRIM(STRTRAN(UPPER(lcIndexes),UPPER(lcIndexTmp),""))
      lcIndexes=ALLTRIM(STRTRAN(lcIndexes," ",""))
      lcIndexes=ALLTRIM(STRTRAN(lcIndexes,",,",","))
      IF RIGHT(lcIndexes,1)==","
        lcIndexes=SUBSTR(lcIndexes,1,LEN(lcIndexes)-1)
      endIF
			IF LEFT(lcIndexes,1)==","
				lcIndexes=SUBSTR(lcIndexes,2)
			endIF
      ON ERROR llOk=.F.
      SET INDEX TO &lcIndexes
      ON ERROR
      IF FILE((lcIndexTmp))
        DELETE FILE (lcIndexTmp)
      endIF
      SET SAFETY &lcSafety
     endIF
  endPROC
***************************
***************************
endDEFINE