*MyHeader
*************************
*
*        
*
*************************
*     , -  General.     
*    ControlSource      
*  .       -      .
*      ,    (   ),
*   General,      ControlSource,
*    ,     .
***********************************************
*   
DEFINE CLASS MyHeader AS Header
  ToolTipText=" "
  cAscending="ASCENDING"
  ControlSource=.NULL.
  nBackColor=.NULL.
  nForeColor=.NULL.
  cNameIndex=.NULL.
*******************************
*******************************
  *       
  PROCEDURE Init
    THIS.nBackColor=THIS.BackColor
    THIS.nForeColor=THIS.ForeColor
  endPROC
*******************************
*******************************
  *         ,
  *    %)
  PROCEDURE MouseDown
    LPARAMETERS nButton, nShift, nXCoord, nYCoord
    THIS.BackColor=ROUND(THIS.BackColor/2,0)
    THIS.ForeColor=RGB(255,255,255)
    THIS.Parent.SetFocus()
  endPROC
*******************************
*******************************
  *   ,    
  PROCEDURE MouseUp
    LPARAMETERS nButton, nShift, nXCoord, nYCoord
    THIS.BackColor=THIS.nBackColor
    THIS.ForeColor=THIS.nForeColor
  endPROC
*******************************
*******************************
	*    ,   ControlSource
  * ,   .    
  * mIndex.     .  .
  PROCEDURE Click
		LOCAL lnI, lnK, llOk, lcCSParent, lcCS, lnRecNo
    IF NOT RIGHT(THIS.Caption,1)=="" OR NOT RIGHT(THIS.Caption,1)==""
      FOR lnI=1 TO THIS.Parent.Parent.ColumnCount
         FOR lnK=1 TO THIS.Parent.Parent.Columns(lnI).ControlCount
           IF THIS.Parent.Parent.Columns(lnI).Objects(lnK).BaseClass=="Header"
						 IF RIGHT(THIS.Parent.Parent.Columns(lnI).Objects(lnK).Caption,1)=="" OR ;
						 		RIGHT(THIS.Parent.Parent.Columns(lnI).Objects(lnK).Caption,1)==""
						   THIS.Parent.Parent.Columns(lnI).Objects(lnK).Caption=;
						   	 ALLTRIM(SUBSTR(THIS.Parent.Parent.Columns(lnI).Objects(lnK).Caption,1,;
						   	 LEN(THIS.Parent.Parent.Columns(lnI).Objects(lnK).Caption)-1))
						 endIF
           endIF
         endFOR
      endFOR
    endIF
    lcCSParent=THIS.Parent.ControlSource
    lcCS=THIS.ControlSource
    lnRecNo=RECNO(THIS.Parent.Parent.RecordSource)
    DO CASE
      CASE OCCURS(".",THIS.Parent.ControlSource)>=2 OR LIKE("*+*",THIS.Parent.ControlSource)
        llOk=.T.
      CASE TYPE("&lcCSParent")=="M"
        llOk=.T.
      CASE TYPE("&lcCSParent")=="G"
        llOk=.T.
    endCASE
    IF llOk
      IF ISNULL(THIS.ControlSource)
        WAIT WINDOWS " " TIMEOUT 0.75
        RETURN .F.
      ELSE
        IF NOT TYPE("&lcCS")=="M" AND NOT TYPE("&lcCS")=="G"
          THIS.mIndex(THIS.ControlSource)
        ELSE
          WAIT WINDOWS " " TIMEOUT 0.75
        endIF
      endIF
    ELSE
      IF ISNULL(THIS.ControlSource)
      	THIS.mIndex(THIS.Parent.ControlSource)
      ELSE
      	THIS.mIndex(THIS.ControlSource)
      endIF
    endIF
		THIS.Parent.Parent.Refresh()
		IF RECCOUNT(THIS.Parent.Parent.RecordSource)>=lnRecNo
      GO RECORD lnRecNo
    endIF
	endPROC
***************************
***************************
	*    /
  PROCEDURE mIndex
		LParameter lpcColumnOrder
		LOCAL lcIndex, lcScending, lcSafety, lcTable
    lcScending=THIS.cAscending
    lcTable=THIS.Parent.Parent.RecordSource
    lcSafety=SET("SAFETY")
    SET SAFETY OFF
    IF ISNULL(THIS.cNameIndex)
      IF OCCURS(".",lpcColumnOrder)>=1
        lpcColumnOrder=SUBSTR(lpcColumnOrder,(AT(".",lpcColumnOrder)+1),;
                       LEN(lpcColumnOrder)-AT(".",lpcColumnOrder))
      endIF
		  SELECT (lcTable)
      lcIndex="i"+SUBSTR(SYS(2015),4,7)
      THIS.mTableView(lpcColumnOrder, lcIndex, lcTable)
		  THIS.cNameIndex=lcIndex
    ELSE
      lcIndex=THIS.cNameIndex
    endIF
    DO CASE
			CASE lcScending=="ASCENDING"
				SET ORDER TO (lcIndex) IN (lcTable) &lcScending
				THIS.cAscending="DESCENDING"
        THIS.Caption=THIS.Caption+" "
			CASE lcScending=="DESCENDING"
				SET ORDER TO (lcIndex) IN (lcTable) &lcScending
				THIS.cAscending="NOSORT"
        THIS.Caption=THIS.Caption+" "
			CASE lcScending=="NOSORT"
				SET ORDER TO
				THIS.cAscending="ASCENDING"
				THIS.Caption=THIS.Caption
			OTHERWISE
				WAIT WINDOW "  ,    , ?"
		endCASE
		SET SAFETY &lcSafety
	ENDPROC
***************************
***************************
*    /.  
*     , ..    
  PROCEDURE mTableView
    LPARAMETERS lpcColumnOrder, lcIndex, lcTable
    LOCAL lnBuffering, llOk, llUpdate
    IF CursorGetProp("SourceType",lcTable)=1 OR CursorGetProp("SourceType",lcTable)=2
      lnBuffering=CursorGetProp("Buffering",lcTable)
      llUpdate=CursorGetProp("SendUpdates",lcTable)
      CursorSetProp("Buffering",3,lcTable)
      CursorSetProp("SendUpdates",.F.)
      llOk=.T.
    endIF
    IF VARTYPE(&lpcColumnOrder)=="C"
	    IF LEN(&lpcColumnOrder)>=100
  	    lpcColumnOrder="LEFT(&lpcColumnOrder,99)"
    	endIF
    endIF
    WAIT WINDOWS ",  " NOWAIT NOCLEAR
    INDEX ON &lpcColumnOrder TAG (lcIndex) ADDITIVE
    WAIT CLEAR
    WAIT WINDOWS " ." NOWAIT
    IF llOk
      CursorSetProp("Buffering",lnBuffering,lcTable)
      CursorSetProp("SendUpdates",llUpdate,lcTable)
    endIF
  endPROC
***************************
***************************
endDEFINE