*MyHeader
*     , -  General.     
*    ControlSource      
*  .       -      .
*      ,    (   ),
*   General,      ControlSource,
*    ,     .
***********************************************
*   
DEFINE CLASS MyHeader AS Header
  ToolTipText=" "
  cTopPicture="bmp\HedTop.bmp"
	cBottomPicture="bmp\HedBottom.bmp"
	cTopPictureGray="bmp\HedTopGray.bmp"
	cBottomPictureGray="bmp\HedBottomGray.bmp"
  cAscending="ASCENDING"
  ControlSource=.NULL.
  lTopBottom=.NULL.
  nBackColor=.NULL.
  nForeColor=.NULL.
  cNameIndex=.NULL.
*******************************
*******************************
  *       
  PROCEDURE Init
    THIS.nBackColor=THIS.BackColor
    THIS.nForeColor=THIS.ForeColor
  endPROC
*******************************
*******************************
  *         ,
  *    %)
  PROCEDURE MouseDown
    LPARAMETERS nButton, nShift, nXCoord, nYCoord
    THIS.BackColor=ROUND(THIS.BackColor/2,0)
    THIS.ForeColor=RGB(255,255,255)
    THIS.Parent.SetFocus()
  endPROC
*******************************
*******************************
  *   ,    
  PROCEDURE MouseUp
    LPARAMETERS nButton, nShift, nXCoord, nYCoord
    THIS.BackColor=THIS.nBackColor
    THIS.ForeColor=THIS.nForeColor
  endPROC
*******************************
*******************************
	*    ,   ControlSource
  * ,   .    
  * mIndex.     .  .
  PROCEDURE Click
		LOCAL lnI, lnK, llOk, lcCSParent, lcCS, lnRecNo
    IF EMPTY(THIS.Picture)
      FOR lnI=1 TO THIS.Parent.Parent.ColumnCount
         FOR lnK=1 TO THIS.Parent.Parent.Columns(lnI).ControlCount
           THIS.Parent.Parent.Columns(lnI).SetAll("Picture","","MyHeader")
         endFOR
      endFOR
    endIF
    lcCSParent=THIS.Parent.ControlSource
    lcCS=THIS.ControlSource
    lnRecNo=RECNO(THIS.Parent.Parent.RecordSource)
    DO CASE
      CASE OCCURS(".",THIS.Parent.ControlSource)>=2 OR LIKE("*+*",THIS.Parent.ControlSource)
        llOk=.T.
      CASE TYPE("&lcCSParent")=="M"
        llOk=.T.
      CASE TYPE("&lcCSParent")=="G"
        llOk=.T.
    endCASE
    IF llOk
      IF ISNULL(THIS.ControlSource)
        WAIT WINDOWS " " TIMEOUT 0.75
        RETURN .F.
      ELSE
        IF NOT TYPE("&lcCS")=="M" AND NOT TYPE("&lcCS")=="G"
          THIS.mIndex(THIS.ControlSource)
        ELSE
          WAIT WINDOWS " " TIMEOUT 0.75
        endIF
      endIF
    ELSE
      IF ISNULL(THIS.ControlSource)
      	THIS.mIndex(THIS.Parent.ControlSource)
      ELSE
      	THIS.mIndex(THIS.ControlSource)
      endIF
    endIF
    THIS.Parent.Parent.Refresh()
    IF RECCOUNT(THIS.Parent.Parent.RecordSource)>=lnRecNo
      GO RECORD lnRecNo
    endIF
	endPROC
***************************
***************************
	*    /
  PROCEDURE mIndex
		LParameter lpcColumnOrder
		LOCAL lcIndex, lcIndexTmp, lcScending, lcSafety, lcTable
    lcScending=THIS.cAscending
    lcTable=THIS.Parent.Parent.RecordSource
    lcSafety=SET("SAFETY")
    SET SAFETY OFF
    lcIndexTmp=ADDBS(SYS(2023))
    IF ISNULL(THIS.cNameIndex)
      IF OCCURS(".",lpcColumnOrder)>=1
        lpcColumnOrder=SUBSTR(lpcColumnOrder,(AT(".",lpcColumnOrder)+1),;
                       LEN(lpcColumnOrder)-AT(".",lpcColumnOrder))
      endIF
		  SELECT (lcTable)
      lcIndex="i"+SUBSTR(SYS(2015),4,7)
		  lcIndexTmp=lcIndexTmp+lcIndex+".tmp"
      IF VARTYPE(&lpcColumnOrder)=="C"
        IF LEN(&lpcColumnOrder)>=100
          lpcColumnOrder="LEFT(&lpcColumnOrder,99)"
        endIF
      endIF
      WAIT WINDOWS ",  " NOWAIT NOCLEAR
      INDEX ON &lpcColumnOrder TO ALLTRIM(lcIndexTmp) ADDITIVE
      WAIT CLEAR
      WAIT WINDOWS " ." NOWAIT
		  THIS.cNameIndex=lcIndex
    ELSE
      lcIndex=THIS.cNameIndex
    endIF
    DO CASE
			CASE lcScending=="ASCENDING"
				SET ORDER TO (lcIndex) IN (lcTable) &lcScending
				THIS.cAscending="DESCENDING"
        THIS.Picture=THIS.cTopPicture
        THIS.lTopBottom=.T.
			CASE lcScending=="DESCENDING"
        SET ORDER TO (lcIndex) IN (lcTable) &lcScending
        THIS.cAscending="NOSORT"
        THIS.Picture=THIS.cBottomPicture
        THIS.lTopBottom=.F.
      CASE lcScending=="NOSORT"
        SET ORDER TO
        THIS.cAscending="ASCENDING"
        THIS.Picture=""
        THIS.lTopBottom=.F.
			OTHERWISE
				WAIT WINDOW "  ,    , ?"
		endCASE
		SET SAFETY &lcSafety
	ENDPROC
***************************
***************************
  *      .
  PROCEDURE RightClick
    LOCAL lnBar, lnClick, lnI, lnK, lcTHISName
    DEFINE POPUP MyRightClick SHORTCUT FROM MROW(),MCOL()
      DEFINE BAR 1 OF MyRightClick PROMPT " " ;
        PICTURE "bmp\hedtopPopUp.bmp"
      DEFINE BAR 2 OF MyRightClick PROMPT " " ;
        PICTURE "bmp\hedbottomPopUp.bmp"
      DEFINE BAR 3 OF MyRightClick PROMPT " " ;
        PICTURE "bmp\nohed.bmp"
      DEFINE BAR 4 OF MyRightClick PROMPT "\-"
      DEFINE BAR 5 OF MyRightClick PROMPT " " ;
        PICTURE "bmp\Loced.bmp"
      DEFINE BAR 6 OF MyRightClick PROMPT " " ;
        PICTURE "bmp\NoLoced.bmp"
    ****************************
      DEFINE BAR 7 OF MyRightClick PROMPT "\-"
      DEFINE BAR 8 OF MyRightClick PROMPT ""
      ON BAR 8 OF MyRightClick ACTIVATE POPUP MyColumns
      DEFINE POPUP MyColumns SHORTCUT RELATIVE
      FOR lnI=1 TO THIS.Parent.Parent.ColumnCount
        FOR lnK=1 TO THIS.Parent.Parent.Columns(lnI).ControlCount
          IF THIS.Parent.Parent.Columns(lnI).Controls(lnK).BaseClass=="Header"
            lcTHISName=THIS.Parent.Parent.Columns(lnI).Controls(lnK).Name
            EXIT
           endIF
        endFOR
        DEFINE BAR (lnI+8) OF MyColumns ;
          PROMPT (THIS.Parent.Parent.Columns(lnI).&lcTHISName..Caption)
        IF THIS.Parent.Parent.Columns(lnI).Visible
          SET MARK OF BAR (lnI+8) OF MyColumns TO .T.
        ELSE
          SET MARK OF BAR (lnI+8) OF MyColumns TO .F.
        endIF
      endFOR
    ****************************
      ON SELECTION POPUP MyRightClick DEACTIVATE POPUP
      ON SELECTION POPUP MyColumns DEACTIVATE POPUP
    *******************************
    ACTIVATE POPUP MyRightClick
    lnBar=BAR()
    DO CASE
      CASE lnBar=0
      CASE lnBar=1
        THIS.cAscending="ASCENDING"
        THIS.lTopBottom=.F.
        THIS.Click()
      CASE lnBar=2
        THIS.cAscending="DESCENDING"
        THIS.lTopBottom=.T.
        THIS.Click()
      CASE lnBar=3
        THIS.cAscending="NOSORT"
        THIS.lTopBottom=.F.
        THIS.Click()
      CASE lnBar=5
        THIS.Parent.Parent.LockColumns=THIS.Parent.ColumnOrder
      CASE lnBar=6
        THIS.Parent.Parent.LockColumns=0
      CASE lnBar>8
        lnBar=lnBar-8
        lnK=0
        FOR lnI=1 TO THIS.Parent.Parent.ColumnCount
          IF THIS.Parent.Parent.Columns(lnI).Visible
            lnK=lnK+1
          endIF
        endFOR
        IF lnK=1
          IF NOT THIS.Parent.Parent.Columns(lnBar).Visible
            THIS.Parent.Parent.Columns(lnBar).Visible=.T.
          ELSE
            WAIT WINDOW "   "
          endIF
        ELSE
          IF THIS.Parent.Parent.Columns(lnBar).Visible
            THIS.Parent.Parent.Columns(lnBar).Visible=.F.
          ELSE
            THIS.Parent.Parent.Columns(lnBar).Visible=.T.
          endIF
        endIF
      OTHERWISE
        WAIT WINDOW "!    !!!"
    endCASE
    RELEASE POPUPS MyColumns
    RELEASE POPUPS MyRightClick
  endPROC
***************************
***************************
  *   
  PROCEDURE MouseEnter
    LPARAMETERS nButton, nShift, nXCoord, nYCoord
    THIS.FontUnderline=.T.
    IF NOT EMPTY(THIS.Picture)
      DO CASE
        CASE THIS.lTopBottom
          THIS.Picture=THIS.cTopPicture
        CASE NOT THIS.lTopBottom
          THIS.Picture=THIS.cBottomPicture
      endCASE
    endIF
  endPROC
***************************
***************************
  *   
  PROCEDURE MouseLeave
    LPARAMETERS nButton, nShift, nXCoord, nYCoord
    THIS.FontUnderline=.F.
    IF NOT EMPTY(THIS.Picture)
      DO CASE
        CASE THIS.lTopBottom
          THIS.Picture=THIS.cTopPictureGray
        CASE NOT THIS.lTopBottom
          THIS.Picture=THIS.cBottomPictureGray
      endCASE
    endIF
  endPROC
***************************
***************************
  *   -
  PROCEDURE Destroy
    LOCAL lcSafety, lcIndexes, lcIndexTmp, llOk
    IF NOT ISNULL(THIS.cNameIndex)
      llOk=.T.
      lcSafety=SET("SAFETY")
      SET SAFETY OFF
      SELECT (THIS.Parent.Parent.RecordSource)
      SET ORDER TO
      lcIndexTmp=ADDBS(SYS(2023))
      lcIndexTmp=lcIndexTmp+THIS.cNameIndex+".tmp"
      lcIndexes=SET("INDEX")
      lcIndexes=ALLTRIM(STRTRAN(UPPER(lcIndexes),UPPER(lcIndexTmp),""))
      lcIndexes=ALLTRIM(STRTRAN(lcIndexes," ",""))
      lcIndexes=ALLTRIM(STRTRAN(lcIndexes,",,",","))
      IF RIGHT(lcIndexes,1)==","
        lcIndexes=SUBSTR(lcIndexes,1,LEN(lcIndexes)-1)
      endIF
			IF LEFT(lcIndexes,1)==","
				lcIndexes=SUBSTR(lcIndexes,2)
			endIF
      ON ERROR llOk=.F.
      SET INDEX TO &lcIndexes
      ON ERROR
      IF FILE((lcIndexTmp))
        DELETE FILE (lcIndexTmp)
      endIF
      SET SAFETY &lcSafety
     endIF
  endPROC
***************************
***************************
endDEFINE